package picocontainer;

import junit.framework.TestCase;
import picocontainer.DefaultPicoContainer;
import picocontainer.DuplicateComponentRegistrationException;
import picocontainer.PicoContainer;
import picocontainer.PicoRegistrationException;
import picocontainer.PicoStartupException;
import picocontainer.UnsatisfiedDependencyStartupException;
import picocontainer.FredImpl;

public class ComponentInteroperationTestCase extends TestCase {

    public void testBasic() throws PicoStartupException, PicoRegistrationException
    {

        WilmaOverride wilmaOverride = new WilmaOverride();
        PicoContainer nano = new OveriddenPicoContainer(wilmaOverride);

        nano.registerComponent(FredImpl.class);
        nano.registerComponent(WilmaImpl.class);

        nano.startup();

        assertTrue("hello should have been called in wilma", wilmaOverride.helloCalled());
    }


}
